      BLOCK DATA
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    BLOCKDAT    INITIALIZE THE ARRAYS IN COMMON ICON.
C   PRGMMR: LUKE LIN         ORG: W/NMC41    DATE: 97-10-22
C
C ABSTRACT: BLOCK DATA IS USED TO INITIALIZE THE CONSTANTS FOR UNPACKING
C   AND SCALING THE GRID POINT DATA FIELDS FOR CONTOURING AND LABELING
C   OF CONTOURS.SCALING THE GRID POINT FIELDS FOR CONTOURING AND
C
C PROGRAM HISTORY LOG:
C   94-09-19  ORIGINAL AUTHOR HENRICHSEN
C   94-09-23  HENRICHSEN  ADDED PRESSURE CHANGE AND HEIGHT CHANGE
C   94-09-29 HENRICHSEN   ADDED # 45 WHICH IS 50% RH.
C   94-10-03 HENRICHSEN   RENAMED LIFTED INDEX 21 & 29 TO
C                         TO BEST LIFTED INDEX "LIB". WHERE
C                         THIS WAS ITEM # 17 IN PEPFAX.
C   94-10-04 HENRICHSEN   ADDED TRAJECTORY TEMPS, VERTICAL DISPLACEMENT,
C                         AND KINDEX.
C   94-12-15 HENRICHSEN   CORRECTED LIFTED INDEX "LIB" TO "LI4" AND
C                         THE PREVIOUS "LI4" TO "LI '.
C   95-02-14 HENRICHSEN   REMOVE ITEM# 13 MAKE VORTICITY FROM U AND V
C                         FIELDS.
C   96-08-08 LUKE LIN     ADD CGRID PRECIP CONSTANTS.
C   97-01-14 LUKE LIN     MODIFY TDL TRAJECTORY CONSTANTS.
C   97-01-15 LUKE LIN     ADD DATA TYPE 41 FOR MOISTURE CONVERGENCE.
C   97-02-25 LUKE LIN     ADD DATA TYPE 38 FOR PROB OF THUNDER STORM
C                         ADD DATA TYPE 39 FOR SEVERE WX
C   97-02-25 LUKE LIN     ADD DATA TYPE 18 FOR WEATHR DEPICTION
C   97-03-07 LUKE LIN     CHANGE 34 and 36 to DN ANOMOLY CHARTS
C   97-04-11 LUKE LIN     INCREASE THE ARRAY FROM 50 TO 60.
C   97-05-30 LUKE LIN     MODIFY PRESSURE CHANGE RESCALE CONSTANTS.
C   97-10-22 LUKE LIN     ADD KEYIDX 54 FOR SURFACE GEOSTROPHIC REL VORTICITY
C
C
C   OUTPUT ARGUMENT LIST:
C     COMMON   - /ICON/ UA1(60),UA2(60),UA3(60),UM1(60),
C              -        UM2(60),UM3(60),KTYPE(60)
C
C REMARKS: THE "KTYPES" 26 AND ABOVE WILL PRODUCE MAPS WITH
C   TWICE AS MANY CONTOURS. FOR EXAMPLE KTYPE(1) WILL PRODUCE A MAP
C   WITH ISOBAR LINES EVERY FOUR MILLIBARS.
C   WHERE AS KTYPE(26) WILL PRODUCE A MAP WITH ISOBAR LINES EVERY
C   TWO MILLIBARS.
C
C ATTRIBUTES:
C   LANGUAGE: F90
C   MACHINE:  CRAY
C
C$$$
C
      COMMON /ICON/ UA1(60),UA2(60),UA3(60),UM1(60),UM2(60),UM3(60),
     1       KTYPE(60)
      CHARACTER*4 KTYPE
      REAL        UA1,UA2,UA3,UM1,UM2,UM3
C
      COMMON /MCON/ IADDB,IADDTAU,NUMTYP,NUMKEY,
     1              MTAU(18),MEAN(18),LMEAN,KDN,LDN
C
      INTEGER     NUMTYP
      INTEGER     MTAU
      CHARACTER*4 MEAN
      LOGICAL    LMEAN
      LOGICAL    KDN
      LOGICAL    LDN
C
      DATA        NUMTYP /13/
      DATA        MTAU/   -36,    12,    84,    96,   108,   120,
     1                    132,   144,   156,   168,   204,   216,
     2                    324,     0,     0,     0,     0,     0/
      DATA        MEAN/'D-3 ','D+0 ','D+3 ','D+3+','D+4 ','D+4+',
     1                 'D+5 ','D+5+','D+6 ','D+6+','D+8 ','D+8+',
     2                 'D+13','    ','    ','    ','    ','    '/
      DATA        KTYPE/'PRS ','HGT ','THK ','HTC ','TMP ','R H ',
     1                  'PCP ','OZNE','VORT','ISO ','WPT ','VEV ',
     2                  '....','SWND','WVHT','ICEG','SICE','WPIX',
     3                  'APCP','LI  ','LI4 ','PSC ','HTC ','MSLP',
     4                  'R H ','PRS ','BHR ','LI  ','LI4 ','PWTR',
     5                  'PRS ','HGT ','THK ','HGT ','TMP ','HGT ',
     6                  'PCP ','PROB','SEVW','ISOT','MCON','VEV ',
     7                  'TPRS','TVWS','R H ','TTM ','TVD ','TKI ',
     8                  'APCP','VEV ','PRS ','PRS ','PRS ','VORT', 
     9                  '    ','    ','    ','    ','    ','    '/ 
C . . . DATA FOR SCALING......  
C
C       VALUES FOR KEYIDX FOLLOW:
C        1 = PESSURE, 2 = HEIGHT, 3 = THICKNESS, 4 = HEIGHT CHANGE,
C        4 = HEIGHT CHANGE WITH CENTERS AS BIG "H" AND BIG "L".
C        5 = TEMPERATURE,
C        6 = RELATIVE HUMIDITY NO CENTERS WITH LINES EVERY 20%.
C        7 = PRECIPITATION
C        8 = OZONE, 9 = VORTICITY, 10 = ISOTACHS, 11 = WIND PLOTS,
C       12 = VERT VEL, 13 = MAKE VORT, 14 = SEA SURFACE WIND SPEED.
C       15 = WAVE HEIGHTS,16 = SOLID ICE EDGE,17 = STRUCTURAL ICE.
C       18 = WEATHER DEPICTION
C       19 = A PCP FOR BIG C GRID FOR 12 HOUR ACCUMULATION
C       20 = SFC TO 500 LIFTED INDEX,
C       21 = BEST LIFTED INDEX ALSO KNOWN AS THE 4-LAYER LIFTED INDEX.
C       22 = PRESSURE CHANGE
C       23 = HEIGHT CHANGE WITH CENTER AS 2 DIGET NUMBER WITH + OR -
C       24 = MSL PRESSURE ANL(VSLPANL)
C       25 = RELATIVE HUMILITY CENTERS WITH LINES EVERY 20%
C       26 = NGM SURFACE PRESSURE,
C       27 = BOUNDRY LAYER HUMIDITY CENTERS WITH LINES EVERY 10%
C       28 = SFC TO 500 LIFTED INDEX,
C       29 = BEST LIFTED INDEX ALSO KNOWN AS THE 4-LAYER LIFTED INDEX.
C       30 = PRICIP WATER
C       31 = PESSURE,32 = HIEGHT,33 = THICKNESS,
C       34 = HEIGHT DN  WITH CENTER AS 2 DIGET NUMBER WITH + OR -
C       35 = TEMPERATURE,
C       36 = HEIGHT DN  WITH CENTER AS 2 DIGET NUMBER WITH + OR -
C       37 = PRECIPITATION
C       38 = PROB OF TSTM  
C       39 = COND PROB OF SEVERE WX   
C       40 = ISOTACHS,
C       41 = MOISTURE CONVERGENCE
C       42 = VERTICAL VELOCITY,
C       43 = TROPOPAUSE PRESSURE,
C       44 = TROPOPAUSE VWS,
C       45 = RELATIVE HUMIDITY CENTERS + THE 50% LINE
C       46 = TRJECTORY TEMPERATURE/DEPOINT TEMPERATURE.
C       47 = TRJECTORY NET VERTICAL DISPLACEMENT.
C       48 = TRJECTORY K INDEX.
C       49 = A PCP FOR BIG C GRID FOR 6 HOUR ACCUMULATION
C       50 = A VV  FOR BIG C GRID
C       51 = NH MSL PRESSURE ANL(VSLPANL), INTERMEDIATE CONTOURS WITH LABELS
C       52 = NH MSL PRESSURE ANL(VSLPANL), INTERMEDIATE CONTOURS WITHOUT LABELS
C       53 = NA MSL PRESSURE ANL(VSLPANL), WITH LABELS
C       54 = SURFACE GEOSTROPHIC REL VORTICITY
C       55-60 OPEN
C
C . . . .ADDITIVE CONSTANTS NEW UNITS TO OLD UNITS.
C
      DATA     UA1/0.0    ,0.0    ,0.0    ,0.0    ,-273.16 ,
     2             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     3             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     4             0.0    ,0.0    ,0.0    ,0.0    ,-273.16 ,
     5             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     6             0.0    ,0.0    ,-273.16,0.0    ,0.0     ,
     7             0.0    ,0.0    ,0.0    ,0.0    ,-273.16 ,
     8             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     9             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     A          -273.16   ,0.0    ,0.0    ,0.0    ,0.0     ,
     B             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     C             0.0    ,0.0    ,0.0    ,0.0    ,0.0     /
C . . . .MULTIPLICATIVE CONSTANTS NEW UNITS TO OLD UNITS.
C
      DATA     UM1/0.01   ,1.0    ,1.0    ,1.0    ,1.0     ,
     2             1.0    ,39.37  ,1.5    ,1.0E5  ,1.94254 ,
     3             1.94254,-1.0E1 ,1.0    ,1.94254,3.280833,
     4             1.0    ,1.0    ,1.0    ,.03937 ,1.0     ,
     5             1.0    ,0.01   ,1.0    , 1.0   ,1.0     ,
     6             1.0    ,1.0    ,1.0     ,1.0   ,0.03937 ,
     7             1.0    ,1.0    ,1.0    ,1.0    ,1.0     ,
     8             0.1    ,.03937 ,1.0    ,1.0    ,1.94254 ,
     9      36000000.0    ,-1.0E3 ,1.0    ,592.084973,1.0  ,
     A             1.0    ,0.01   ,1.0     ,.03937,-1.0E1  ,
     B             0.01   ,0.01   ,0.01   , 1.0E5 ,1.0     ,
     C             1.0    ,1.0    ,1.0    , 1.0   ,1.0     /
C . . . .ADDITIVE CONSTANTS FOR CONTOURING.
C
      DATA     UA2/0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     2             6.5    ,.98    ,0.0    ,0.0    ,6.5     ,
     3             0.0    ,0.0    ,0.0    ,-2.5   ,8.0     ,
     4             0.0    ,0.0    ,0.0    ,0.98   ,0.0     ,
     5             0.0    ,0.0    ,0.0    ,0.0    ,6.5     ,
     6             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     7             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     8             0.0    ,.94    ,0.0    ,0.0    ,0.0     ,
     9             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     A             0.0    ,0.0    ,0.0    ,0.96   ,0.0     ,
     B             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     C             0.0    ,0.0    ,0.0    ,0.0    ,0.0     /
C . . . .MULTIPLICATIVE CONSTANTS FOR CONTOURING.
C
      DATA     UM2/0.25   ,.016667,.016667,.016667,0.2     ,
     2             0.05   ,2.0    ,0.5    ,0.5    ,0.05    ,
     3             1.0    ,0.5    ,1.0    ,0.1    ,0.125   ,
     4             0.5    ,0.5    ,1.0    ,2.0    ,0.25    ,
     5             0.25   ,0.25   ,.016667,.50    ,0.05    ,
     6             0.1    ,0.1    ,.5     ,0.5    ,8.0     ,
     7             0.50   ,.033334,.033334,.016667,0.4     ,
     8             0.16667,4.0    ,0.1    ,0.5    ,0.10    ,
     9             0.20   ,1.0    ,.04    ,1.0    ,.02     ,
     A             0.20   ,0.05   ,.25    ,4.0    ,.33334  ,
     B             0.25   ,0.25   ,0.25   ,0.5    ,1.0     ,
     C             1.0    ,1.0    ,1.0    ,1.0    ,1.0     /
C . . . .ADDITIVE CONSTANTS FOR CENTER FINDING/CONTOUR LABELING.
C
      DATA     UA3/0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     2             -6.5   ,-.98   ,0.0    ,0.0    ,-6.5    ,
     3             0.0    ,0.0    ,0.0    ,2.5    ,-8.0    ,
     4             0.0    ,0.0    ,0.0    ,-.98   ,0.0     ,
     5             0.0    ,0.0    ,0.0    ,0.0    ,-6.5    ,
     6             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     7             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     8             0.0    ,-.94   ,0.0    ,0.0    ,0.0     ,
     9             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     A             0.0    ,0.0    ,0.0    ,-.96   ,0.0     ,
     B             0.0    ,0.0    ,0.0    ,0.0    ,0.0     ,
     C             0.0    ,0.0    ,0.0    ,0.0    ,0.0     /
C . . . .MULTIPLICATIVE CONSTANTS FOR CENTER FINDING/CONTOUR LABELING.
C
      DATA     UM3/4.0    ,6.0    ,6.0    ,6.0    ,5.0     ,
     2             20.0   ,50.    ,20.    ,2.0    ,20.0    ,
     3             1.0    ,2.0    ,1.0    ,10.0   ,8.0     ,
     4             2.0    ,2.0    ,1.0    ,50.0   , 4.0    ,
     5             4.0    ,4.0    ,6.0    ,2.0    ,20.0    ,
     6             10.0   ,10.0   ,2.0    ,2.0    ,12.5    ,
     7             2.0    ,3.0    ,3.0    ,6.0    ,2.5     ,
     8             60.0   ,25.0   ,10.0   ,2.0    ,10.0    ,
     9             5.0    ,1.0    ,25.0   ,1.0    ,50.0    ,
     A             5.0    ,20.0   ,4.0    ,25.0   ,3.0     ,
     B             4.0    ,4.0    ,4.0    ,2.0    ,1.0     ,
     C             1.0    ,1.0    ,1.0    ,1.0    ,1.0     /
C
      END
